<html>
<head>
<title>OGRE: OgreSphere.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSphere.h</h1><a href="OgreSphere_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Sphere_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Sphere_H_</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00046"></a><a class="code" href="classOgre_1_1Sphere.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">protected</span>:
<a name="l00049"></a><a class="code" href="classOgre_1_1Sphere.html#912c305cf5821240fe88a3a7ef59e67b">00049</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mRadius;
<a name="l00050"></a><a class="code" href="classOgre_1_1Sphere.html#4a6065226f4fbd7bc5f3cbe0c385d9c7">00050</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mCenter;
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00053"></a><a class="code" href="classOgre_1_1Sphere.html#93cb05f8025668db930ef81a34dca47b">00053</a>         <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>() : mRadius(1.0), mCenter(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO) {}
<a name="l00058"></a><a class="code" href="classOgre_1_1Sphere.html#bd0dc8dd45b400a07d71115652d2dc20">00058</a>         <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; center, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius)
<a name="l00059"></a>00059             : mRadius(radius), mCenter(center) {}
<a name="l00060"></a>00060 
<a name="l00062"></a><a class="code" href="classOgre_1_1Sphere.html#8c0a5dee80bf790cdc5bd2a68f73a4c7">00062</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getRadius(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRadius; }
<a name="l00063"></a>00063 
<a name="l00065"></a><a class="code" href="classOgre_1_1Sphere.html#afe80cad31edd668b09981a6f836c8b1">00065</a>         <span class="keywordtype">void</span> setRadius(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius) { mRadius = radius; }
<a name="l00066"></a>00066 
<a name="l00068"></a><a class="code" href="classOgre_1_1Sphere.html#b33e56a0df43b2dfe3b72b59757e6f69">00068</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getCenter(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCenter; }
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="classOgre_1_1Sphere.html#f2cd29ca81e68cdeb65b91a2667d6fbc">00071</a>         <span class="keywordtype">void</span> setCenter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; center) { mCenter = center; }
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="classOgre_1_1Sphere.html#26fc8402579d1256e222f34b6ac0ecf3">00074</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; s)<span class="keyword"> const</span>
<a name="l00075"></a>00075 <span class="keyword">        </span>{
<a name="l00076"></a>00076             <span class="keywordflow">return</span> (s.<a class="code" href="classOgre_1_1Sphere.html#4a6065226f4fbd7bc5f3cbe0c385d9c7">mCenter</a> - mCenter).<a class="code" href="classOgre_1_1Vector3.html#d465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>() &lt;=
<a name="l00077"></a>00077                 <a class="code" href="classOgre_1_1Math.html#626ae51af294ae54cee7e1e530937d7e">Math::Sqr</a>(s.<a class="code" href="classOgre_1_1Sphere.html#912c305cf5821240fe88a3a7ef59e67b">mRadius</a> + mRadius);
<a name="l00078"></a>00078         }
<a name="l00080"></a><a class="code" href="classOgre_1_1Sphere.html#ce0763611fbf75e156d6e34d399d5468">00080</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box)<span class="keyword"> const</span>
<a name="l00081"></a>00081 <span class="keyword">        </span>{
<a name="l00082"></a>00082             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, box);
<a name="l00083"></a>00083         }
<a name="l00085"></a><a class="code" href="classOgre_1_1Sphere.html#adca485853a6ae4535a3a9347ab6119b">00085</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane)<span class="keyword"> const</span>
<a name="l00086"></a>00086 <span class="keyword">        </span>{
<a name="l00087"></a>00087             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, plane);
<a name="l00088"></a>00088         }
<a name="l00090"></a><a class="code" href="classOgre_1_1Sphere.html#a127d312d66a63b160825c4650c92e14">00090</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword">        </span>{
<a name="l00092"></a>00092             <span class="keywordflow">return</span> ((v - mCenter).squaredLength() &lt;= <a class="code" href="classOgre_1_1Math.html#626ae51af294ae54cee7e1e530937d7e">Math::Sqr</a>(mRadius));
<a name="l00093"></a>00093         }
<a name="l00094"></a>00094         
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     };
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="preprocessor">#endif</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
